package com.rebusland.fin.derivatives.eq.server.input.model;

import org.joda.beans.ImmutableBean;
import org.joda.beans.gen.BeanDefinition;
import org.joda.beans.gen.PropertyDefinition;

import com.rebusland.fin.derivatives.eq.server.common.model.SerializableBeanFacade;
import com.rebusland.fin.derivatives.eq.server.enums.model.CallPut;

import java.util.Map;
import java.util.NoSuchElementException;
import org.joda.beans.Bean;
import org.joda.beans.JodaBeanUtils;
import org.joda.beans.MetaBean;
import org.joda.beans.MetaProperty;
import org.joda.beans.impl.direct.DirectFieldsBeanBuilder;
import org.joda.beans.impl.direct.DirectMetaBean;
import org.joda.beans.impl.direct.DirectMetaProperty;
import org.joda.beans.impl.direct.DirectMetaPropertyMap;

@BeanDefinition
public class VanillaOption extends SerializableBeanFacade implements ImmutableBean {
	@PropertyDefinition (validate = "notNull")
	private final CallPut callPut;

	@PropertyDefinition (validate = "notNull")
	private final Double strike;

	//------------------------- AUTOGENERATED START -------------------------
	/**
	 * The meta-bean for {@code VanillaOption}.
	 * @return the meta-bean, not null
	 */
	public static VanillaOption.Meta meta() {
		return VanillaOption.Meta.INSTANCE;
	}

	static {
		MetaBean.register(VanillaOption.Meta.INSTANCE);
	}

	/**
	 * Returns a builder used to create an instance of the bean.
	 * @return the builder, not null
	 */
	public static VanillaOption.Builder builder() {
		return new VanillaOption.Builder();
	}

	/**
	 * Restricted constructor.
	 * @param builder  the builder to copy from, not null
	 */
	protected VanillaOption(VanillaOption.Builder builder) {
		JodaBeanUtils.notNull(builder.callPut, "callPut");
		JodaBeanUtils.notNull(builder.strike, "strike");
		this.callPut = builder.callPut;
		this.strike = builder.strike;
	}

	@Override
	public VanillaOption.Meta metaBean() {
		return VanillaOption.Meta.INSTANCE;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the callPut.
	 * @return the value of the property, not null
	 */
	public CallPut getCallPut() {
		return callPut;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the strike.
	 * @return the value of the property, not null
	 */
	public Double getStrike() {
		return strike;
	}

	//-----------------------------------------------------------------------
	/**
	 * Returns a builder that allows this bean to be mutated.
	 * @return the mutable builder, not null
	 */
	public Builder toBuilder() {
		return new Builder(this);
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == this) {
			return true;
		}
		if (obj != null && obj.getClass() == this.getClass()) {
			VanillaOption other = (VanillaOption) obj;
			return JodaBeanUtils.equal(callPut, other.callPut) &&
					JodaBeanUtils.equal(strike, other.strike);
		}
		return false;
	}

	@Override
	public int hashCode() {
		int hash = getClass().hashCode();
		hash = hash * 31 + JodaBeanUtils.hashCode(callPut);
		hash = hash * 31 + JodaBeanUtils.hashCode(strike);
		return hash;
	}

	@Override
	public String toString() {
		StringBuilder buf = new StringBuilder(96);
		buf.append("VanillaOption{");
		int len = buf.length();
		toString(buf);
		if (buf.length() > len) {
			buf.setLength(buf.length() - 2);
		}
		buf.append('}');
		return buf.toString();
	}

	protected void toString(StringBuilder buf) {
		buf.append("callPut").append('=').append(JodaBeanUtils.toString(callPut)).append(',').append(' ');
		buf.append("strike").append('=').append(JodaBeanUtils.toString(strike)).append(',').append(' ');
	}

	//-----------------------------------------------------------------------
	/**
	 * The meta-bean for {@code VanillaOption}.
	 */
	public static class Meta extends DirectMetaBean {
		/**
		 * The singleton instance of the meta-bean.
		 */
		static final Meta INSTANCE = new Meta();

		/**
		 * The meta-property for the {@code callPut} property.
		 */
		private final MetaProperty<CallPut> callPut = DirectMetaProperty.ofImmutable(
				this, "callPut", VanillaOption.class, CallPut.class);
		/**
		 * The meta-property for the {@code strike} property.
		 */
		private final MetaProperty<Double> strike = DirectMetaProperty.ofImmutable(
				this, "strike", VanillaOption.class, Double.class);
		/**
		 * The meta-properties.
		 */
		private final Map<String, MetaProperty<?>> metaPropertyMap$ = new DirectMetaPropertyMap(
				this, null,
				"callPut",
				"strike");

		/**
		 * Restricted constructor.
		 */
		protected Meta() {
		}

		@Override
		protected MetaProperty<?> metaPropertyGet(String propertyName) {
			switch (propertyName.hashCode()) {
				case 548617169:  // callPut
					return callPut;
				case -891985998:  // strike
					return strike;
			}
			return super.metaPropertyGet(propertyName);
		}

		@Override
		public VanillaOption.Builder builder() {
			return new VanillaOption.Builder();
		}

		@Override
		public Class<? extends VanillaOption> beanType() {
			return VanillaOption.class;
		}

		@Override
		public Map<String, MetaProperty<?>> metaPropertyMap() {
			return metaPropertyMap$;
		}

		//-----------------------------------------------------------------------
		/**
		 * The meta-property for the {@code callPut} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<CallPut> callPut() {
			return callPut;
		}

		/**
		 * The meta-property for the {@code strike} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<Double> strike() {
			return strike;
		}

		//-----------------------------------------------------------------------
		@Override
		protected Object propertyGet(Bean bean, String propertyName, boolean quiet) {
			switch (propertyName.hashCode()) {
				case 548617169:  // callPut
					return ((VanillaOption) bean).getCallPut();
				case -891985998:  // strike
					return ((VanillaOption) bean).getStrike();
			}
			return super.propertyGet(bean, propertyName, quiet);
		}

		@Override
		protected void propertySet(Bean bean, String propertyName, Object newValue, boolean quiet) {
			metaProperty(propertyName);
			if (quiet) {
				return;
			}
			throw new UnsupportedOperationException("Property cannot be written: " + propertyName);
		}

	}

	//-----------------------------------------------------------------------
	/**
	 * The bean-builder for {@code VanillaOption}.
	 */
	public static class Builder extends DirectFieldsBeanBuilder<VanillaOption> {

		private CallPut callPut;
		private Double strike;

		/**
		 * Restricted constructor.
		 */
		protected Builder() {
		}

		/**
		 * Restricted copy constructor.
		 * @param beanToCopy  the bean to copy from, not null
		 */
		protected Builder(VanillaOption beanToCopy) {
			this.callPut = beanToCopy.getCallPut();
			this.strike = beanToCopy.getStrike();
		}

		//-----------------------------------------------------------------------
		@Override
		public Object get(String propertyName) {
			switch (propertyName.hashCode()) {
				case 548617169:  // callPut
					return callPut;
				case -891985998:  // strike
					return strike;
				default:
					throw new NoSuchElementException("Unknown property: " + propertyName);
			}
		}

		@Override
		public Builder set(String propertyName, Object newValue) {
			switch (propertyName.hashCode()) {
				case 548617169:  // callPut
					this.callPut = (CallPut) newValue;
					break;
				case -891985998:  // strike
					this.strike = (Double) newValue;
					break;
				default:
					throw new NoSuchElementException("Unknown property: " + propertyName);
			}
			return this;
		}

		@Override
		public Builder set(MetaProperty<?> property, Object value) {
			super.set(property, value);
			return this;
		}

		@Override
		public VanillaOption build() {
			return new VanillaOption(this);
		}

		//-----------------------------------------------------------------------
		/**
		 * Sets the callPut.
		 * @param callPut  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder callPut(CallPut callPut) {
			JodaBeanUtils.notNull(callPut, "callPut");
			this.callPut = callPut;
			return this;
		}

		/**
		 * Sets the strike.
		 * @param strike  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder strike(Double strike) {
			JodaBeanUtils.notNull(strike, "strike");
			this.strike = strike;
			return this;
		}

		//-----------------------------------------------------------------------
		@Override
		public String toString() {
			StringBuilder buf = new StringBuilder(96);
			buf.append("VanillaOption.Builder{");
			int len = buf.length();
			toString(buf);
			if (buf.length() > len) {
				buf.setLength(buf.length() - 2);
			}
			buf.append('}');
			return buf.toString();
		}

		protected void toString(StringBuilder buf) {
			buf.append("callPut").append('=').append(JodaBeanUtils.toString(callPut)).append(',').append(' ');
			buf.append("strike").append('=').append(JodaBeanUtils.toString(strike)).append(',').append(' ');
		}

	}

	//-------------------------- AUTOGENERATED END --------------------------
}
